import tadsPM.Arbol;
import tadsPM.EmptyTreeException;
import utilsPM.InOut;

public class ArbolIOint
{
    public Arbol leer_arbol_int(int marca, InOut io) throws Exception

    /* Lee el arbol en preorden: primero la raiz y luego,
       recursivamente, los hijos izquierdo y derecho.
       Las marcas ocupan el papel del arbol nulo */

    /* Ejemplo: el arbol 

                           1
                         /   \
                        2     3

       se lee 1 2 0 0 3 0 0 (o con los numeros en distintas lineas) */

    {
	Arbol b, c;

	int x = io.readint();
	Integer wx = new Integer(x);

	if (x!=marca)
	{
	    b = leer_arbol_int(marca,io);		// hijo izquierdo
	    c = leer_arbol_int(marca,io);		// hijo derecho
	    b.plantar(wx, c);
	}
	else
	{
	    b = new Arbol();
	    b.a_nulo();
	}

	return b;

    }


    public void escribir_arbol_int(Arbol a, InOut io) throws Exception

       /* Escribe el arbol en inorden: primero el hijo izquierdo,
          luego la raiz y por ultimo el derecho.*/
 
    {
	Arbol aux1, aux2;

        if (!a.es_nulo())
	{
	    aux1 = new Arbol();
	    aux2 = new Arbol();
	    try
	    {
	        aux1.hi(a);
		aux2.hd(a);
		escribir_arbol_int(aux1,io);
		Integer wraiz = (Integer) a.raiz();
		io.writeln(wraiz.intValue());
		escribir_arbol_int(aux2,io);
	    }
	    catch (EmptyTreeException e)
	    {
		System.err.println("Error en escribir_arbol");
	    }
	}
    }
}





