package tadsPM;

import utilsPM.InOut;
 
public class Palabra {

  /* Palabras de hasta MAXLONG caracteres. Incluye las operaciones de
     lectura y escritura */

  private static final int MAXLONG=20;

  private char[] letras;
  private int longitud;

  public Palabra(){
    longitud=0;
    letras= new char[MAXLONG];
  }
  
  public Palabra(Palabra p){
    /* Crea una palabra nueva a partir de otra. Es una forma
       de implementar la funcion de copia */
    
        letras= new char[MAXLONG];
        for (int i = 0; i< p.longitud; i++){letras[i]=p.letras[i];}
    longitud=p.longitud;
  }
 
  /*  public Object clone() {
    try {
      Palabra p = (Palabra)super.clone();
      p.letras = (char[])letras.clone();
      return p;
    }catch (CloneNotSupportedException e){
      throw new InternalError(e.toString());
    }
  }
  */

  public static int longitud_maxima()
  /* Para consultar la logitud maxima permitida por la implementacion */

  {
    return MAXLONG;
  }

  public Palabra(InOut canal) throws Exception, LongitudException{
    /* Crea una palabra leyendola del InOut. Es util cuando 
       se quiera que cada palabra leida sea un objeto nuevo */

    String s = canal.readword();
    longitud=s.length();
    if (longitud>MAXLONG) throw new LongitudException("Palabra demasiado larga");
    letras = new char[MAXLONG];
    // letras = s.toCharArray();
    s.getChars(0,longitud,letras,0);

  }

  public void leer_palabra(InOut canal) throws Exception, LongitudException{
    /* El parametro implicito pasa a ser la palabra leida. Util cuando
       sea irrelevante si la palabra leida es nueva o no */

    String s = canal.readword();
    longitud=s.length();
    if (longitud>MAXLONG) throw new LongitudException("Palabra demasiado larga");
    s.getChars(0,longitud,letras,0);
  }


  public void anadir_letra(char c) throws Exception, LongitudException{

    if (longitud>=MAXLONG) throw new LongitudException("Palabra demasiado larga");
    letras[longitud]=c;
    longitud++;
  }

  public int longitud()
  {
    return longitud;
  }
  
  public boolean marca()
   /* Retorna si la palabra es un '.'. Para que sea util hay que
      escribir el punto separado de la palabra anterior */ 
  {
    return (longitud==1 && letras[0]=='.');
  }

  public boolean iguales (Palabra p){
    boolean b;
    if (longitud!=p.longitud) {b=false;}
    else {  
      b=true;
      int i=0;
      while (b && i<longitud) {
	b=letras[i]==p.letras[i];
        i++;
      } 
    }
    return b;
  }
  
  public void escribir_palabra(InOut canal) throws Exception{
    for (int i = 0; i<= longitud;i++){canal.write(letras[i]);} 
  }
}
