package tadsPM.polinomio;

public class Poli{

  private int[] coefs;
  private int grado;
  static final private int MAX_GRADO =10;

  public static int grado_maximo() 
  /* Para consultar el maximo grado permitido por la implementacion */ 

  {
    return MAX_GRADO;
  }

  public void crear_poli (int c, int i) throws ExponenteException
  /* i ha de estar entre 0 y MAX_GRADO */
  /* El parametro implicito es cx^i */

  {
    if (i<0) throw new ExponenteException("Exponente negativo");
    if (i>MAX_GRADO) throw new ExponenteException("Exponente demasiado grande");
    coefs = new int[MAX_GRADO+1];
    int j =0;
    while (j<=MAX_GRADO){
      coefs[j]=0;
      j++;
    }   
    coefs[i]=c;
    grado=i;
  }

  public void modif_coef (int c, int i) throws ExponenteException
  /* i ha de estar entre 0 y MAX_GRADO */
  /* El parametro implicito cambia su termino i-simo a cx^i */

  {
    if (i<0) throw new ExponenteException("Exponente negativo");
    if (i>MAX_GRADO) throw new ExponenteException("Exponente demasiado grande");   
    coefs[i]=c;
    if (grado<i && c!=0) grado=i;
    if (grado==i && c==0) 
      while (grado>0 && coefs[grado]==0) grado--;
  }

   
  public void suma_poli(Poli p)
  /* cierto */
  /* El parametro implicito pasa a ser la suma de su valor antiguo y p */   

  {
    if (p.grado>grado) {grado=p.grado;}
    int i=0;
    while (i<=grado){
      coefs[i]+=p.coefs[i];
      i++;
    }
    while (grado>0 && coefs[grado]==0) grado--;
  }
   


  public int grado()
  /* cierto */
  /* retorna el grado del parametro implicito */

  {
    return grado;
  }

  public int coef(int i) throws ExponenteException
  /* i ha de estar entre 0 y el grado del parametro implicito */
  /* retorna el coeficiente i-esimo del parametro implicito */

  {
    if (i<0) throw new ExponenteException("Exponente negativo");
    if (i>grado) throw new ExponenteException("Exponente demasiado grande");
    return coefs[i];
  }


  public void copiar_poli(Poli p)
  /* cierto */
  /* el parametro implicito pasa a ser una copia de p */

  {
    grado=p.grado;
    coefs= new int [MAX_GRADO+1];
    int i=0;
    while (i<=grado){
      coefs[i]=p.coefs[i];
      i++; 
    }
  }

}
